// OpeningBookEntry.cpp: Implementierung der Klasse COpeningBookEntry.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "OpeningBookEntry.h"

/***************************************************************************
 * Static Class members
 **************************************************************************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

/***************************************************************************
 * Constructor / Destructor
 **************************************************************************/

OpeningBookEntry::OpeningBookEntry()
{
    theLock = 0;
	nextEntry = NULL;
	rating_good = 0;
	rating_neutral = 0;
	openingMove = new Move();
	openingMove->MoveType = Move::NULL_MOVE;
}

OpeningBookEntry::~OpeningBookEntry()
{
	if ( openingMove != NULL ) {
		delete openingMove;
		openingMove = NULL;
	}
}

/***************************************************************************
 * Operations
 **************************************************************************/

// OpeningBookEntry::write takes the entry and writes in binary mode into the ostream passed in method call
ostream& OpeningBookEntry::write( ostream &os ) const
{
	os.write( ( char* )&rating_good,    sizeof( rating_good ) );
	os.write( ( char* )&rating_neutral, sizeof( rating_neutral ) );
	os.write( ( char* )&theLock,        sizeof( theLock ) );
	// write move-object of this entry
	openingMove->write( os );
	return os;
}

// OpeningBookEntry::read loads the entry in binary mode out of istream passed in method call
istream& OpeningBookEntry::read( istream &is )
{
	is.read( ( char* )&rating_good,    sizeof( rating_good ) );
	is.read( ( char* )&rating_neutral, sizeof( rating_neutral ) );
	is.read( ( char* )&theLock,        sizeof( theLock ) );
	// read move-object of this entry
	openingMove->read( is );
	return is;
}
