// PlayerAI.cpp: Implementierung der Klasse PlayerAI.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PlayerAI.h"

/***************************************************************************
 * Static Class members
 **************************************************************************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

/***************************************************************************
 * Constructor / Destructor
 **************************************************************************/

PlayerAI::PlayerAI( int whichPlayer, int whichType, OpeningBook* ref ) : Player()
{
    this->SetSide( whichPlayer );
    Agent = AISearchAgent::MakeNewAgent( whichType, ref );
}

PlayerAI::~PlayerAI()
{
	delete Agent;
}

/***************************************************************************
 * Operations
 **************************************************************************/

// Attach a search agent to the AI player
bool PlayerAI::AttachSearchAgent( AISearchAgent* theAgent )
{
    Agent = theAgent;
    return true;
}

// Getting a move from the machine
bool PlayerAI::GetMove( Board* theBoard, Move* mov )
{
	Agent->PickBestMove( theBoard, mov );

/*	SMALL HACK
	computer having some problems with transposition-table
	and setting enemy checkmate
	simply delete transposition-table when there is a
	checkmate move
	*/	if (mov->MoveEvaluation >= (AISearchAgent::ALPHABETA_MAXVAL - 100)) {
		Agent->TransTable.Clear();
		Agent->TransTableBlack.Clear();
//		*Output::cout << "small HACK - delete Transtable" << endl;
	}
		


	// check if opponent is checkmate
		
	Board Successor;
	MoveListGenerator mlg;
	bool checkmate = true;
	
	Successor.Clone( theBoard );
	Successor.ApplyMove( mov );
	if ( mlg.ComputeLegalMoves( &Successor ) == true )
		{
		Move *moves;
		// if all legal moves leaves the king in check
		// ComputeLegalMoves return false
		while ( ( moves = mlg.Next() ) != NULL )
			{
			Board Successor2;
			MoveListGenerator mlg2;
			Successor2.Clone( &Successor );
			Successor2.ApplyMove( moves );
			if ( mlg2.ComputeLegalMoves( &Successor2 ) == true )
				checkmate = false;
			}
		
		if ( checkmate )
			mov->MoveType = Move::MOVE_CHECKMATE;
		}

	return true;
}

istream& PlayerAI::read( istream& is ) const
{
	Agent->read( is );
	return is;
}

ostream& PlayerAI::write( ostream& os ) const
{
	Agent->write( os );
	return os;
}

void PlayerAI::ShowStats()
{
	Agent->ShowStats();
}
