// PlayerAIWinBoard extends PlayerAI for being able to communicate
// with WinBoard. Only the GetMove() - Method has to be changed
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PlayerAIWinBoard.h"

/***************************************************************************
 * Constructor / Destructor
 **************************************************************************/
PlayerAIWinBoard::PlayerAIWinBoard( int whichPlayer, int whichType, OpeningBook* ref ) : PlayerAI( whichPlayer, whichType, ref )
{

}

PlayerAIWinBoard::~PlayerAIWinBoard()
{

}

/***************************************************************************
 * Operations
 **************************************************************************/

// GetMove uses the normal GetMove of PlayerAI - extendet by sending the move to Winboard
bool PlayerAIWinBoard::GetMove( Board* theBoard, Move* mov )
{
	// call the derived method
	this->PlayerAI::GetMove( theBoard, mov );

	// WinBoard extension
	
	// Thinking output for move out of the opening book
	if ( OpeningBook::used_for_last_move ) {
		stringstream iostream;
		string smove;
		string sconn;
		string source;
		string dest;
		string sstream;
		string out;

		out = "0\t0\t0\t0\topening: ";

		iostream.clear();
		iostream << OpeningBook::variantno;
		iostream >> sstream;
		out = out + sstream + "/";

		iostream.clear();
		iostream << OpeningBook::variants;
		iostream >> sstream;
		out = out + sstream + ": ";

		iostream.clear();
		iostream << mov->SourceSquare;
		iostream >> source;
		if ( source.size() < 2 ) source = "0" + source;

		iostream.clear();

		iostream << mov->DestinationSquare;
		iostream >> dest;
		
		if ( dest.size() < 2 ) dest = "0" + dest;
		
		smove = source + " " + dest;


		Board::SquareToCoord( smove, &sconn );

		out = out + sconn;
			
		WinBoardConnection::getInstance()->send( WinBoardConnection::CMD_THINKING, out );
	}
	
	// converting move in a string valid for Winboard
	stringstream iostream;
	string smove;
	string sconn;
	string source;
	string dest;

	iostream << mov->SourceSquare;
	iostream >> source;
	if ( source.size() < 2 ) source = "0" + source;

	iostream.clear();

	iostream << mov->DestinationSquare;
	iostream >> dest;
	if ( dest.size() < 2 ) dest = "0" + dest;
	smove = source + " " + dest;

	Board::SquareToCoord( smove, &sconn );

	WinBoardConnection* myWinBoardConnection = WinBoardConnection::getInstance();

	// resign
	if ( mov->MoveType == Move::MOVE_RESIGN ) {
		myWinBoardConnection->send( WinBoardConnection::CMD_RESIGN, "" );
	} else
	// promotion move
		   if ( mov->MoveType == Move::MOVE_STALEMATE ) {
	} else if ( mov->MoveType == Move::MOVE_PROMOTION_BISHOP ) {
		myWinBoardConnection->send( WinBoardConnection::CMD_MOVE, sconn + "b" );	
	} else if ( mov->MoveType == Move::MOVE_PROMOTION_KNIGHT ) {
		myWinBoardConnection->send( WinBoardConnection::CMD_MOVE, sconn + "k" );	
	} else if ( mov->MoveType == Move::MOVE_PROMOTION_QUEEN ) {
		myWinBoardConnection->send( WinBoardConnection::CMD_MOVE, sconn + "q" );	
	} else if ( mov->MoveType == Move::MOVE_PROMOTION_ROOK ) {
		myWinBoardConnection->send( WinBoardConnection::CMD_MOVE, sconn + "r" );	
	} else 
	// normal move
		myWinBoardConnection->send( WinBoardConnection::CMD_MOVE, sconn );

	return true;
}
