// TranspositionTable.h: Schnittstelle fr die Klasse TranspositionTable.
//
//////////////////////////////////////////////////////////////////////

#if !defined( AFX_TRANSPOSITIONTABLE_H__BD41163A_DE2F_48D8_A152_E162D33019D4__INCLUDED_ )
#define AFX_TRANSPOSITIONTABLE_H__BD41163A_DE2F_48D8_A152_E162D33019D4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TranspositionEntry.h"

class TranspositionTable  
{
private:
	/***************************************************************************
	 * DATA MEMBERS
	 **************************************************************************/

	// Data
	TranspositionEntry** Table;
	int Side;


public:
	void SetSide( int Side );
	void ShowStats();
	int getNumEntries(int depth = -1);
	// The size of a transposition table, in entries
	static const int TABLE_SIZE;

	TranspositionTable(int Side = -1);
	virtual ~TranspositionTable();

	/**************************************************************************
	 * PUBLIC METHODS
	 *************************************************************************/
	
	// boolean LookupBoard
	// Verify whether there is a stored evaluation for a given board.
	// If so, return TRUE and copy the appropriate values into the
	// output parameter
	bool LookupBoard( Board* theBoard, Move* theMove );
	bool LookupBoard( Board* theBoard, TranspositionEntry** theEntry );
	// public StoreBoard
	// Store a good evaluation found through alphabeta for a certain board position
	bool StoreBoard( Board* theBoard, int eval, int evalType, int depth, int timeStamp, Move* mov, int theNode );

	bool PrintToFile( const char *filename, bool simplified = false );

	void Clear();
	void SafeClear();

	istream& read ( istream &is );
	ostream& write( ostream &os ) const;
};

#endif // !defined( AFX_TRANSPOSITIONTABLE_H__BD41163A_DE2F_48D8_A152_E162D33019D4__INCLUDED_ )
