// WinBoardConnection.h: Schnittstelle fr die Klasse WinBoardConnection.
//
//////////////////////////////////////////////////////////////////////

#if !defined( AFX_WINBOARDCONNECTION_H__F8D07934_6536_494D_8CFF_8A564CC2CDDB__INCLUDED_ )
#define AFX_WINBOARDCONNECTION_H__F8D07934_6536_494D_8CFF_8A564CC2CDDB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class WinBoardConnection  
{
public:
	static const int CMD_NONE;
	static const int CMD_UNKNOWN;
	static const int CMD_NEW;
	static const int CMD_USERMOVE;
	static const int CMD_PROTOVER;
	static const int CMD_XBOARD;
	static const int CMD_QUIT;
	static const int CMD_THINKING;
	static const int CMD_FEATURE;
	static const int CMD_ILLEGALMOVE;
	static const int CMD_ERROR;
	static const int CMD_MOVE;
	static const int CMD_RESIGN;
	static const int CMD_REMOVE;
	static const int CMD_WHITE;
	static bool changeAI;
	static bool firstMove;

	static bool isActive;
	static WinBoardConnection* getInstance();
	
	WinBoardConnection();
	virtual ~WinBoardConnection();
	
	void send( int whichCommand, string par );
	string getPlayerName( int Side );
	int	getPlayerType( int Side );
	bool ScanInput( int *whichCommand, string *par );

private:
	static const int MAX_CMD;
	static WinBoardConnection* self;
	
	string* commandStrings;
	ofstream traceConn;

	void getCommand( string* cmd );
	void SendFeatures();
	static const string traceConnFilename;
};





#endif // !defined( AFX_WINBOARDCONNECTION_H__F8D07934_6536_494D_8CFF_8A564CC2CDDB__INCLUDED_ )
